package com.rthoni.stssaguenay.business;

import android.content.Context;

import com.luticate.utils.dbo.LuDataAccessConfigDbo;
import com.rthoni.stssaguenay.dataaccess.STSDataAccess;
import com.rthoni.stssaguenay.dbo.FavouriteStopDbo;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.List;
import java.util.Vector;

/**
 * Created by robin on 9/29/16.
 */
public class STSBusiness {

    private static LuDataAccessConfigDbo _config = null;

    public static LuDataAccessConfigDbo getConfig()
    {
        if (_config == null) {
            _config = new LuDataAccessConfigDbo();
            _config.setBaseUrl("http://gigi-eth:8089/");
        }
        return _config;
    }

    public static List<FavouriteStopDbo> getFavouriteStops(Context ctx)
    {
        String str = STSDataAccess.getFavouriteStopsJson(ctx);
        List<FavouriteStopDbo> dbos = new Vector<>();
        JSONArray json;
        try {
            json = new JSONArray(str);
            for (int i = 0; i < json.length(); ++i) {
                FavouriteStopDbo dbo = new FavouriteStopDbo();
                dbo.fromJson(json.getJSONObject(i));
                dbos.add(dbo);
            }
        } catch (JSONException e) {
            e.printStackTrace();
        }
        return dbos;
    }

    public static void setFavouriteStops(Context ctx, List<FavouriteStopDbo> favourites)
    {
        JSONArray json = new JSONArray();
        for (FavouriteStopDbo favouriteStopDbo : favourites) {
            json.put(new JSONObject(favouriteStopDbo.toArray()));
        }
        STSDataAccess.setFavouriteStopsJson(ctx, json.toString());
    }
}
