package com.rthoni.stssaguenay.ui.activities;

import android.content.Intent;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.View;

import com.luticate.utils.business.LuRequest;
import com.rthoni.stssaguenay.R;
import com.rthoni.stssaguenay.business.STSBusiness;
import com.rthoni.stssaguenay.dbo.FavouriteStopDbo;
import com.rthoni.stssaguenay.ui.fragments.HomeFragment;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;

public class MainActivity extends AppCompatActivity {

    public static int ADD_FAVOURITE_STOP_REQUEST_CODE = 1;

    private boolean _goToHome = false;

    @BindView(R.id.fab)
    FloatingActionButton _fab;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        LuRequest.init(this);

        setContentView(R.layout.activity_main);
        ButterKnife.bind(this);

        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        _fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                goToAddStop();
            }
        });

        goToHome();
    }

    @Override
    protected void onResume() {
        if (_goToHome) {
            _goToHome = false;
            goToHome();
        }
        super.onResume();
    }

    public void goToHome()
    {
        _fab.show();
        HomeFragment f = new HomeFragment();
        getSupportFragmentManager().beginTransaction().replace(R.id.container, f).commit();
    }

    public void goToStop()
    {
        _fab.hide();

    }

    public void goToAddStop()
    {
        Intent intent = new Intent(this, StopPickerActivity.class);
        startActivityForResult(intent, ADD_FAVOURITE_STOP_REQUEST_CODE);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == ADD_FAVOURITE_STOP_REQUEST_CODE && resultCode == RESULT_OK) {
            FavouriteStopDbo favouriteStopDbo = new FavouriteStopDbo();
            try {
                JSONObject obj = new JSONObject(data.getStringExtra(StopPickerActivity.STOP_EXTRA_NAME));
                favouriteStopDbo.fromJson(obj);
            } catch (JSONException e) {
                e.printStackTrace();
                return;
            }
            List<FavouriteStopDbo> favouriteStopDbos = STSBusiness.getFavouriteStops(this);
            favouriteStopDbos.add(favouriteStopDbo);
            STSBusiness.setFavouriteStops(this, favouriteStopDbos);
            _goToHome = true;
        }
        super.onActivityResult(requestCode, resultCode, data);
    }

    //    @Override
//    public boolean onCreateOptionsMenu(Menu menu) {
//        // Inflate the menu; this adds items to the action bar if it is present.
//        getMenuInflater().inflate(R.menu.menu_main, menu);
//        return true;
//    }

//    @Override
//    public boolean onOptionsItemSelected(MenuItem item) {
//        // Handle action bar item clicks here. The action bar will
//        // automatically handle clicks on the Home/Up button, so long
//        // as you specify a parent activity in AndroidManifest.xml.
//        int id = item.getItemId();
//
//        //noinspection SimplifiableIfStatement
//        if (id == R.id.action_settings) {
//            return true;
//        }
//
//        return super.onOptionsItemSelected(item);
//    }
}
